# gdcm::VR Class Reference

VR class This is adapted from DICOM standard The biggest difference is the INVALID VR and the composite one that differ from standard (more like an addition) This allow us to represent all the possible case express in the DICOMV3 dict. More...

`#include <gdcmVR.h>`

List of all members.

## Public Types

enum

VRType {
INVALID = 0,
AE = 1,
AS = 2,
AT = 4,
CS = 8,
DA = 16,
DS = 32,
DT = 64,
FD = 128,
FL = 256,
IS = 512,
LO = 1024,
LT = 2048,
OB = 4096,
OF = 8192,
OW = 16384,
PN = 32768,
SH = 65536,
SL = 131072,
SQ = 262144,
SS = 524288,
ST = 1048576,
TM = 2097152,
UI = 4194304,
UL = 8388608,
UN = 16777216,
US = 33554432,
UT = 67108864,
OB_OW = OB | OW,
US_SS = US | SS,
US_SS_OW = US | SS | OW,
VL16 = AE | AS | AT | CS | DA | DS | DT | FD | FL | IS | LO | LT | PN | SH | SL | SS | ST | TM | UI | UL | US,
VL32 = OB | OW | OF | SQ | UN | UT,
VRASCII = AE | AS | CS | DA | DS | DT | IS | LO | LT | PN | SH | ST | TM | UI | UT,
VRBINARY = AT | FL | FD | OB | OF | OW | SL | SQ | SS | UL | UN | US,
VR_VM1 = AS | LT | ST | UT | SQ | OF | OW | OB | UN,
VRALL = VRASCII | VRBINARY,
VR_END = UT+1
}

## Public Member Functions

| VR (VRType vr=INVALID)
bool | Compatible (VR const &vr) const
int | GetLength () const
unsigned int | GetSize () const
unsigned int | GetSizeof () const
bool | IsDual () const
bool | IsVRFile () const
| operator VRType () const
std::istream & | Read (std::istream &is)
const std::ostream & | Write (std::ostream &os) const

## Static Public Member Functions

static bool | CanDisplay (VRType vr)
static uint32_t | GetLength (VRType vr)
static const char * | GetVRString (VRType vr)
static const char * | GetVRStringFromFile (VRType vr)
static VRType | GetVRType (const char *vr)
static VRType | GetVRTypeFromFile (const char *vr)
static bool | IsASCII (VRType vr)
static bool | IsASCII2 (VRType vr)
static bool | IsBinary (VRType vr)
static bool | IsBinary2 (VRType vr)
static bool | IsSwap (const char *vr)
static bool | IsValid (const char *vr1, VRType vr2)
static bool | IsValid (const char *vr)

## Friends

std::ostream & | operator<< (std::ostream &os, const VR &vr)

## Detailed Description

VR class This is adapted from DICOM standard The biggest difference is the INVALID VR and the composite one that differ from standard (more like an addition) This allow us to represent all the possible case express in the DICOMV3 dict.

Note:
  VALUE REPRESENTATION (VR) Specifies the data type and format of the Value(s) contained in the Value Field of a Data Element. VALUE REPRESENTATION FIELD: The field where the Value Representation of a Data Element is stored in the encoding of a Data Element structure with explicit VR.

Examples:

  GenAllVR.cxx, and GenFakeIdentifyFile.cxx.

## Member Enumeration Documentation

enum gdcm::VR::VRType

Enumerator:

  INVALID |
  AE |
  AS |
  AT |
  CS |
  DA |
  DS |
  DT |
  FD |
  FL |
  IS |
  LO |
  LT |
  OB |
  OF |
  OW |
  PN |
  SH |
  SL |
  SQ |
  SS |
  ST |
  TM |
  UI |
  UL |
  UN |
  US |
  UT |
  OB_OW |
  US_SS |
  US_SS_OW |
  VL16 |
  VL32 |
  VRASCII |
  VRBINARY |
  VR_VM1 |
  VRALL |
  VR_END |

## Constructor & Destructor Documentation

gdcm::VR::VR | ( | VRType | vr = `INVALID` | ) | `[inline]`

## Member Function Documentation

static bool gdcm::VR::CanDisplay | ( | VRType | vr | ) | `[static]`

bool gdcm::VR::Compatible | ( | VR const & | vr | ) | const

static uint32_t gdcm::VR::GetLength | ( | VRType | vr | ) | `[inline, static]`

int gdcm::VR::GetLength | ( |  | ) | const`[inline]`

unsigned int gdcm::VR::GetSize | ( |  | ) | const`[inline]`

References AE, US_SS, and VRTypeTemplateCase.

unsigned int gdcm::VR::GetSizeof | ( |  | ) | const

static const char* gdcm::VR::GetVRString | ( | VRType | vr | ) | `[static]`

Referenced by gdcm::operator<<().

static const char* gdcm::VR::GetVRStringFromFile | ( | VRType | vr | ) | `[static]`

static VRType gdcm::VR::GetVRType | ( | const char * | vr | ) | `[static]`

static VRType gdcm::VR::GetVRTypeFromFile | ( | const char * | vr | ) | `[static]`

static bool gdcm::VR::IsASCII | ( | VRType | vr | ) | `[static]`

static bool gdcm::VR::IsASCII2 | ( | VRType | vr | ) | `[static]`

static bool gdcm::VR::IsBinary | ( | VRType | vr | ) | `[static]`

static bool gdcm::VR::IsBinary2 | ( | VRType | vr | ) | `[static]`

bool gdcm::VR::IsDual | ( |  | ) | const

static bool gdcm::VR::IsSwap | ( | const char * | vr | ) | `[static]`

static bool gdcm::VR::IsValid | ( | const char * | vr | ) | `[static]`

static bool gdcm::VR::IsValid | ( | const char * | vr1,
|  | VRType | vr2
| ) |  | `[static]`

bool gdcm::VR::IsVRFile | ( |  | ) | const

gdcm::VR::operator VRType | ( |  | ) | const`[inline]`

std::istream& gdcm::VR::Read | ( | std::istream & | is | ) | `[inline]`

References gdcmDebugMacro, INVALID, and VR_END.

const std::ostream& gdcm::VR::Write | ( | std::ostream & | os | ) | const`[inline]`

References gdcmAssertAlwaysMacro, and INVALID.

## Friends And Related Function Documentation

std::ostream& operator<< | ( | std::ostream & | os,
|  | const VR & | vr
| ) |  | `[friend]`

The documentation for this class was generated from the following file:

- gdcmVR.h